from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker

from .settings import settings

DB_URL = settings.db_url

engine = create_engine(
    DB_URL, connect_args={"check_same_thread": False}
)

SessionLocal = sessionmaker(autocommit=False, autoflush=False, bind=engine)

# Dependency
def get_db():
    db = SessionLocal()
    try:
        yield db
    finally:
        db.close()
